<template>
    <div class="referral-v2-history">
        <div class="referral-v2-history__search-block">
            <div class="referral-v2-history__date-picker-container">
                <el-date-picker popper-class="referral-v2-history__date-picker" v-model="pageData.StartDate"
                :disabled-date="disabledDatesForStartDate"
                :clearable="false" format="MM-DD-YYYY" :size="sizes.width < 640 ? 'large' : 'default'" />
                <span>{{ $t("referral_to") }}</span>
                <el-date-picker popper-class="referral-v2-history__date-picker" 
                :disabled-date="disabledDatesForEndDate" class="hide-prefix" v-model="pageData.EndDate"
                :clearable="false" format="MM-DD-YYYY" :size="sizes.width < 640 ? 'large' : 'default'" />
            </div>
            <div class="referral-v2-history__action-container">
                <el-button 
                @click="getPageData" round 
                class="action-button-primary"
                :disabled="!isSubmitable" >
                    <span>{{ $t('submit') }}</span>
                </el-button>
            </div>
        </div>
        <div v-loading="pageData.isGettingPageData" class="m-8" v-if="pageData.isGettingPageData"></div>
        <div v-else class="referral-v2-history-table">
            <el-table :data="pageData.requestHistory" border style="width: 100%;">
                <el-table-column width="auto">
                    <template #header>
                        <div class="text-center p-2">
                            <p class="header-text">{{ $t('request_date') }}</p>
                            <p class="header-text hide-on-desktop mt-1">{{ $t('approved_date') }}</p>
                        </div>
                    </template>
                    <template #default="scope: { row: PlayerRedeemRequest }">
                        <div class="text-center body-cell">
                            <p class="body-cell__text">{{ scope.row.FormattedRequestedDate }}</p>
                            <p class="body-cell__text hide-on-desktop mt-1">{{ scope.row.FormattedApprovedDate }}</p>
                        </div>
                    </template>
                </el-table-column>
                <el-table-column width="auto" v-if=" sizes.width >= 1024 ">
                    <template #header>
                        <div class="text-center p-2">
                            <p class="header-text">{{ $t('approved_date') }}</p>
                        </div>
                    </template>
                    <template #default=" scope: { row: PlayerRedeemRequest } ">
                        <div class="text-center body-cell">
                            <p class="body-cell__text" :key=" scope.row.FormattedApprovedDate ">{{
                                scope.row.FormattedApprovedDate }}</p>
                        </div>
                    </template>
                </el-table-column>
                <el-table-column width="auto" v-if=" sizes.width >= 1024 ">
                    <template #header>
                        <div class="text-center p-2">
                            <p class="header-text">{{ $t('redeem_amount') }}</p>
                        </div>
                    </template>
                    <template #default=" scope: { row: PlayerRedeemRequest } ">
                        <div class="text-center body-cell">
                            <p class="body-cell__text" :key=" scope.row.FormattedRedeemAmount ">{{ scope.row.FormattedRedeemAmount }}</p>
                        </div>
                    </template>
                </el-table-column>
                <el-table-column width="auto" min-width="120px">
                    <template #header>
                        <div class="text-center p-2">
                            <p class="header-text hide-on-desktop mb-1">{{ $t('redeem_amount') }}</p>
                            <p class="header-text">{{ $t('min_turnover_to_withdraw') }}</p>
                        </div>
                    </template>
                    <template #default=" scope: { row: PlayerRedeemRequest } ">
                        <div class="text-center body-cell">
                            <p class="body-cell__text hide-on-desktop mb-1">{{ scope.row.FormattedRedeemAmount }}</p>
                            <p class="body-cell__text">{{ scope.row.FormattedWithdrawalLimit }}</p>
                        </div>
                    </template>
                </el-table-column>
                <el-table-column width="auto">
                    <template #header>
                        <div class="text-center p-2">
                            <p class="header-text">{{ $t('status') }}</p>
                        </div>
                    </template>
                    <template #default=" scope: { row: PlayerRedeemRequest } ">
                        <div class="text-center body-cell">
                            <p class="body-cell__text" :class="scope.row.FormattedStatusColorClass">{{ $t(scope.row.FormattedStatus) }}</p>
                        </div>
                    </template>
                </el-table-column>
            </el-table>
        </div>
    </div>
</template>
<script setup lang="ts">
import { useReferralV2History } from '~~/composables/referralv2/useReferralV2';
import { PlayerRedeemRequest } from '~~/models/referral/referralV2';

const { sizes } = useResponsiveDimensions();
const { pageData, getPageData, disabledDatesForStartDate, disabledDatesForEndDate, isSubmitable } = useReferralV2History();
onMounted(() => {
    getPageData();
});
</script>
<style scoped>
.referral-v2-history .referral-v2-history-table :deep(.el-table__empty-block) {
    border: none;
}
.referral-v2-history__search-block :deep(.el-date-editor.hide-prefix .el-input__prefix) {
    display: none;
}
.referral-v2-history__search-block :deep(.el-date-editor .el-input__inner) {
    --el-input-border-color: rgba(0,0,0,0);
    --el-input-bg-color: rgba(0,0,0, 0);
    --el-input-hover-border-color: rgba(0,0,0,0);
    --el-input-focus-border-color: rgba(0,0,0,0);
    color: var(--text5);
    text-align: center;
    font-size: 12px;
    font-style: normal;
    font-weight: 400;
    line-height: normal;
}
.referral-v2-history__search-block :deep(.el-date-editor .el-input__inner:focus, .el-date-editor .el-input__inner:hover) {
    color: var(--primary);
}
.referral-v2-history__date-picker-container {
    display: flex;
    align-items: center;
    gap: 8px;
    width: 100%;
    border-radius: 4px;
    transition: box-shadow 0.2s cubic-bezier( 0.645, 0.045, 0.355, 1 );
    box-shadow: 0 0 0 1px var(--border) inset;
    background-color: rgba(0,0,0, 0.1);
}
.referral-v2-history__date-picker-container:hover, .referral-v2-history__date-picker-container:focus-within {
    box-shadow: 0 0 0 1px var(--primary) inset;
}
.referral-v2-history .el-button.action-button-primary {
    display: flex;
    width: 160px;
    height: 32px;
    padding: 8px 16px;
    justify-content: center;
    align-items: center;
    gap: 8px;
    border-radius: 16px;
    background: var(--primary);
}

.referral-v2-history__search-block {
    display: flex;
    flex-direction: column;
    align-items: center;
    gap: 8px;
    align-self: stretch;
}

@media only screen and (min-width: 640px) {
    .uc-section.is-collapse .referral-v2-history__date-picker-container {  
        min-width: 360px;
        max-width: 360px;
    }
    .uc-section.is-collapse .referral-v2-history__search-block {
        flex-direction: row;
    }
    .uc-section.is-collapse .referral-v2-history .el-button.action-button-primary {
        width: 100%;
    }
    .uc-section.is-collapse .referral-v2-history__action-container {
        width: 100%;
    }
}
@media only screen and (min-width: 768px) {
    .referral-v2-history__date-picker-container {  
        min-width: 360px;
        max-width: 360px;
    }
    .referral-v2-history__search-block {
        flex-direction: row;
    }
    .referral-v2-history .el-button.action-button-primary {
        width: 100%;
    }
    .referral-v2-history__action-container {
        width: 100%;
    }
    .referral-v2-history__search-block {
        max-width: 530px;
        margin-left: auto;
    }
}

.referral-v2-history :deep(.el-table .el-table__header-wrapper .cell),
.referral-v2-history :deep(.el-table .el-table__header-wrapper .el-table__cell) {
    padding: 0;
}

.referral-v2-history :deep(.el-table .el-table__body-wrapper .cell),
.referral-v2-history :deep(.el-table .el-table__body-wrapper .el-table__cell) {
    padding: 0;
}

.referral-v2-history-table .body-cell {
    display: flex;
    flex-direction: column;
    gap: 4px;
    padding: 8px;
}
.referral-v2-history-table .body-cell .body-cell__text {
    color: var(--text5);
    text-align: center;
    font-size: 12px;
    font-style: normal;
    font-weight: 400;
    line-height: normal;
    text-transform: capitalize;
}

.referral-v2-history-table .body-cell .body-cell__text.neutral {
    color: var(--text5);
}
.referral-v2-history-table .body-cell .body-cell__text.failure {
    color: var(--failure, #FF265C);
}
.referral-v2-history-table .body-cell .body-cell__text.success {
    color: var(--success, #03B001);
}

.referral-v2-history :deep(.el-table .el-table__header-wrapper .cell .header-text) {
    color: var(--text5);
    text-align: center;
    font-size: 12px;
    font-style: normal;
    font-weight: 500;
    line-height: normal;
    text-transform: capitalize;
}

/* table body scroll */
.referral-v2-history :deep(.el-table .el-table__body-wrapper .el-scrollbar__wrap) {
    /* height: calc(var(--table-height) - 57px); */
    --table-header-height: 65px;
    height: calc(var(--table-height) - var(--table-header-height));
}

@media only screen and (min-width: 428px) {
    .referral-v2-history :deep(.el-table .el-table__body-wrapper .el-scrollbar__wrap) {
        --table-header-height: 50px;
    }
}
@media only screen and (min-width: 1024px) {
    .referral-v2-history :deep(.el-table .el-table__body-wrapper .el-scrollbar__wrap) {
        --table-header-height: 30px;
    }
}

/* table body scroll end */
.referral-v2-history-table {
    margin-top: 1rem;
    border: 2px solid var(--border);
    border-radius: 8px;
}

.referral-v2-history :deep(div.el-table) {
    --el-table-border: 2px solid var(--border);
    --el-table-bg-color: transparent;
    --el-table-tr-bg-color: transparent;
    --table-height: 69vh;
    height: var(--table-height);
}

.referral-v2-history :deep(div.el-table) table .el-table__cell:first-child {
    border-left: unset;
}

.referral-v2-history :deep(div.el-table) table .el-table__cell:last-child {
    border-right: unset;
}

.referral-v2-history :deep(div.el-table) table th:first-child {
    border-left: unset;
}

.referral-v2-history :deep(div.el-table) table th:last-child {
    border-right: unset;
}

.referral-v2-history :deep(div.el-table) tr:last-child td:first-child {
    border-bottom-left-radius: 0;
}

.referral-v2-history :deep(div.el-table) tr:last-child td:last-child {
    border-bottom-right-radius: 0;
}

.referral-v2-history__info .history-btn {
    width: 100%;
    max-width: 160px;
    margin: 0 auto;
}

.referral-v2-history__info,
.referral-v2-history__info .left,
.referral-v2-history__info .right {
    display: flex;
    flex-direction: column;
    gap: 8px;
}

.referral-v2-history__info {
    padding-bottom: 1rem;
}

.referral-v2-history__info-stats {
    display: flex;
    justify-content: space-between;
    align-items: center;
    height: 40px;
}

.referral-v2-history__info-stats .title {
    color: var(--text5);
    font-size: 14px;
    font-style: normal;
    font-weight: 500;
    line-height: normal;
}

.referral-v2-history__info-stats .count {
    color: var(--text);
    font-size: 14px;
    font-style: normal;
    font-weight: 500;
    line-height: normal;
}

.referral-v2-history__info-stats .count.history {
    color: #FFF;
    font-size: 20px;
    font-weight: 700;
}

.referral-v2-history__info-action {
    display: flex;
    justify-content: center;
}

@media only screen and (min-width: 1024px) {
    .referral-v2-history__info {
        justify-content: space-between;
    }

    .referral-v2-history__info,
    .referral-v2-history__info .left,
    .referral-v2-history__info .right {
        flex-direction: row;
        align-items: center;
    }

    .referral-v2-history__info .left {
        gap: 24px;
    }

    .referral-v2-history__info-stats {
        gap: 8px;
    }

    .referral-v2-history-table .hide-on-desktop {
        display: none;
    }
    .referral-v2-history :deep(div.el-table) {
        /* --table-height: 67vh; */
        /* --table-height: 90vh; */
    }
}
</style>